#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <linux/types.h>

#define		EPC_BASEADDR			MMU_ADDR(0x81400000)

#define		HW_RELEASE				*(volatile unsigned long *) (EPC_BASEADDR + 0x00)
#define		COUNTER_CTRL			*(volatile unsigned long *) (EPC_BASEADDR + 0x38)

extern unsigned long MMU_DEV_BASE;
extern unsigned long MMU_MAP_BASE;
extern unsigned long MMU_MAP_SIZE;

extern unsigned long MMU_ADDR (unsigned long phys);
unsigned long do_mmap (unsigned long addr, unsigned long size);
unsigned long do_munmap (unsigned long addr, unsigned long size);

int main(int argc, char *argv[])
{
	int i=0;

	// map 0x80000000 - 0x8FFFFFFF od physical address space
	do_mmap(MMU_DEV_BASE, MMU_MAP_SIZE);

	// get HW version
	printf ("HW version: %02x\n", HW_RELEASE);

	// toggle LEDs
	printf ("Toggling LEDs.. (press CTRL-C to quit)\n");
	while (1)
	{
		COUNTER_CTRL = (1<<(28+i));
		i = (i+1)%4;
		usleep(100000);
	}

	do_munmap(MMU_MAP_BASE, MMU_MAP_SIZE);

	return 0;
}

